package com.ksyun;

import com.ksyun.model.SmsDetail;
import com.ksyun.model.SmsInfo;
import com.ksyun.model.SmsReport;
import com.ksyun.model.SmsUp;
import com.ksyun.model.Template;
import com.ksyun.model.rdto.AddSmsSignResult;
import com.ksyun.model.rdto.BaseResult;
import com.ksyun.model.rdto.CreateTemplateResult;
import com.ksyun.model.rdto.DeleteSmsSignResult;
import com.ksyun.model.rdto.MobileLocationResult;
import com.ksyun.model.rdto.ModifySmsSignResult;
import com.ksyun.model.rdto.QuerySmsSignResult;
import com.ksyun.model.rdto.SendDiffSmsResult;
import com.ksyun.model.rdto.SendSmsResult;
import com.ksyun.model.rdto.SendTimingSmsResult;
import com.ksyun.model.rdto.TemplateResult;
import com.ksyun.util.UtilAll;
import org.joda.time.DateTime;
import org.junit.Test;

import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Date;
import java.util.List;
import java.util.Map;

public class SmsServiceTest {

//    String ak = "";
//
//    String sk = "";
//
//    String tplId = "";
//
//    String signName = "";
//
//    Map<String, String> maps = Collections.emptyMap();
//
//    List<String> mobiles = Arrays.asList(""/*, ""*/);

    String ak = "";
    String sk = "";
    String tplId = "";
    String signName = "";
    Map<String, String> tplParams = Collections.singletonMap("", "");
    //开启了权限，才能使用下面这两个参数
    String content = "";
    String smsType = "";
    List<String> mobiles = Arrays.asList("+", "+");

    @Test
    public void sendSms() {
        SmsService smsService = new SmsService(ak, sk);
        for (String mobile : mobiles) {
            SendSmsResult sendSmsResult = smsService.sendSms(mobile, tplId, tplParams, content, smsType,signName);
            System.out.println("---" + UtilAll.toJson(sendSmsResult));
        }
    }

    @Test
    public void batchSendSms() {
        SmsService smsService = new SmsService(ak, sk);
        SendSmsResult sendSmsResult = smsService.batchSendSms(mobiles, tplId, tplParams, content, smsType,signName);
        System.out.println("---" + UtilAll.toJson(sendSmsResult));
    }

    @Test
    public void sendDiffSms() {
        SmsService smsService = new SmsService(ak, sk);
        List<SmsInfo> list = new ArrayList<>();
        int i = 1;
        for (String mobile : mobiles) {
            SmsInfo smsInfo = new SmsInfo(mobile, tplParams, content + i++);
            list.add(smsInfo);
        }
        SendDiffSmsResult sendDiffSmsResult = smsService.sendDiffSms(list, tplId, smsType,signName);
        System.out.println("---" + UtilAll.toJson(sendDiffSmsResult));
    }

    @Test
    public void mobileLocation() throws UnsupportedEncodingException {
        SmsService smsService = new SmsService(ak, sk);
        MobileLocationResult MobileLocationResult = smsService.mobileLocation(mobiles);
        System.out.println("---" + UtilAll.toJson(MobileLocationResult));
    }


    @Test
    public void pullSmsReport() {
        SmsService smsService = new SmsService(ak, sk);
        List<SmsReport> rs = smsService.pullSmsReport(1);
        System.out.println(UtilAll.toJson(rs));
    }

    @Test
    public void pullSmsUp() {
        SmsService smsService = new SmsService(ak, sk);
        List<SmsUp> rs = smsService.pullSmsUp(1);
        System.out.println(UtilAll.toJson(rs));
    }

    @Test
    public void querySmsDetail() {
        SmsService smsService = new SmsService(ak, sk);
        List<SmsDetail> smsDetails = smsService.querySmsDetail(new Date(), mobiles.get(0), null, null);
        System.out.println(UtilAll.toJson(smsDetails));
    }

    @Test
    public void deliveredSms() {
        SmsService smsService = new SmsService(ak, sk);
        BaseResult baseResult = smsService.deliveredSms("sss", null, new Date());
        System.out.println(UtilAll.toJson(baseResult));
    }

    @Test
    public void listTemplates() {
        SmsService smsService = new SmsService(ak, sk);
        List<Template> templates = smsService.listTemplates(1, 10);
        System.out.println(UtilAll.toJson(templates));
    }

    @Test
    public void getTemplateById() {
        SmsService smsService = new SmsService(ak, sk);
        TemplateResult templateResult = smsService.getTemplateById(2386);
        System.out.println(UtilAll.toJson(templateResult));
    }


    @Test
    public void createTemplate() {
        SmsService smsService = new SmsService(ak, sk);
        CreateTemplateResult createTemplateResult = smsService.createTemplate(1, "验证码模板", "您好，您的验证码是{code}", "申请描述");
        System.out.println(UtilAll.toJson(createTemplateResult));
    }

    @Test
    public void sendTimingSms() {
        SmsService smsService = new SmsService(ak, sk);
        SendTimingSmsResult sendTimingSmsResult = smsService.sendTimingSms(2, mobiles, "您好,定时短信", signName,DateTime.now().plusMinutes(5).toDate());
        System.out.println(UtilAll.toJson(sendTimingSmsResult));
    }

    @Test
    public void addSmsSign() {
        SmsService smsService = new SmsService(ak, sk);
        AddSmsSignResult addSmsSignResult = smsService.addSmsSign("金山-Live3", 1, "公司申请");
        System.out.println(UtilAll.toJson(addSmsSignResult));
    }

    @Test
    public void modifySmsSign() {
        SmsService smsService = new SmsService(ak, sk);
        ModifySmsSignResult modifySmsSignResult = smsService.modifySmsSign("305195", "a name", 1, "test");
        System.out.println(UtilAll.toJson(modifySmsSignResult));
    }

    @Test
    public void querySmsSign() {
        SmsService smsService = new SmsService(ak, sk);
        QuerySmsSignResult querySmsSignResult = smsService.querySmsSign("305195");
        System.out.println(UtilAll.toJson(querySmsSignResult));
    }

    @Test
    public void deleteSmsSign() {
        SmsService smsService = new SmsService(ak, sk);
        DeleteSmsSignResult report = smsService.deleteSmsSign("305188");
        System.out.println(UtilAll.toJson(report));
    }


}
